#include<bits/stdc++.h>

#define endl '\n'

using namespace std;



const int MAXN = 400000;

const int MAXM = 800000;



vector<pair<int, int>> edges[MAXN+1];

vector<int> treeEdges[MAXN+1];



int levels[MAXN+1];

long long times[MAXN+1];

int parents[MAXN+1];



int timer = 1;

int inTimes[MAXN+1];

int outTimes[MAXN+1];



void bfs(int start) {

    queue<int> q;

    q.push(start);

    levels[start] = times[start] = 0;



    while (q.size()) {

        int u = q.front(); q.pop();



        for (auto p: edges[u]) {

            int v = p.first;

            int w = p.second;

            if (levels[u]+1 > levels[v]) continue;



            if (levels[v] == MAXN) q.push(v);

            if (times[u]+w < times[v]) parents[v] = u;

            levels[v] = levels[u]+1;

            times[v] = min(times[v], times[u]+w);

        }

    }

}



void dfs(int u) {

    inTimes[u] = timer++;

    for (int v: treeEdges[u]) {

        if (inTimes[v] != 0) continue;

        dfs(v);

    }

    outTimes[u] = timer++;

}



bool hasPath(int x, int y) {

    return inTimes[x] <= inTimes[y] && outTimes[y] <= outTimes[x];

}



void solve(int x, int y) {

    if (!hasPath(x, y)) {

        cout << 0 << endl;

        return;

    }



    int levelsDiff = levels[x] != levels[y] ? levels[y]-levels[x]-1 : 0;

    int timesDiff = times[y]-times[x];

    cout << levelsDiff << " " << timesDiff << endl;

}



int main() {

    ios_base::sync_with_stdio(0); cin.tie(0);



    int n, m; cin >> n >> m;

    for (int i = 0; i < m; i++) {

        int u, v, w; cin >> u >> v >> w;

        edges[u].push_back({v, w});

        edges[v].push_back({u, w});

    }

    for (int i = 1; i <= n; i++) levels[i] = MAXN;

    for (int i = 1; i <= n; i++) times[i] = 1e18;



    bfs(1);



    for (int i = 2; i <= n; i++) treeEdges[parents[i]].push_back(i);



    dfs(1);



    solve(1, n);

    int q; cin >> q;

    for (int i = 0; i < q; i++) {

        int x, y; cin >> x >> y;

        solve(x, y);

    }



    return 0;

}
