#include <iostream>
#include <queue>
#include <vector>
#include <limits.h>
using namespace std;
typedef long long ll;
const ll maxn = 4e5+10, maxm = 8e5+10, maxt = 1e4+10, inf = 1e15;

struct node {
    ll x, cities, dist;
    node(){}
    node(ll _x, ll _cities, ll _dist) {
        x = _x;
        cities = _cities;
        dist = _dist;
    }
};

queue < node > q;
pair < ll, ll > path[maxn];
vector < pair < ll, ll > > v[maxn];

void init_path() {
   q.push({1, -1, 0});
   path[1] = {-1, 0};
   while (!q.empty()) {
       node top = q.front();
       q.pop();
       if (top.dist > path[top.x].second) continue;
       //cout << "top: " << top.x << ' ' << top.cities << ' ' << top.dist << '\n';
       for (auto p : v[top.x]) {
            ll y = p.first;
            ll ed = p.second;
            if (path[y].first == -2 || (path[y].first == top.cities+1 && path[y].second > top.dist + ed)) {
                path[y] = {top.cities+1, top.dist + ed};
                q.push({y, top.cities+1, top.dist + ed});
            }
       }
   }
}

ll n, m, x, y, d;

int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    for (ll i = 0 ; i < maxn ; ++i)
        path[i] = {-2, inf};
    cin >> n >> m;
    for (ll i = 0 ; i < m ; ++i) {
        cin >> x >> y >> d;
        v[x].push_back({y, d});
        v[y].push_back({x, d});
    }
    init_path();
    cout << path[n].first << ' ' << path[n].second << '\n';
    return 0;
}

/*
5 6
1 2 1
2 3 2
1 3 5
3 4 1
3 5 3
4 5 1
3
2 3
3 5
1 4

*/