#include <iostream>
#include <queue>
#include <vector>
#include <limits.h>
using namespace std;
typedef long long ll;
const ll maxn = 4e5+10, maxm = 8e5+10, maxt = 1e4+10, inf = 1e15;

struct node {
    ll x, cities, dist, parent, edge_dist;
    node(){}
    node(ll _x, ll _cities, ll _dist, ll _parent, ll _edge_dist) {
        x = _x;
        cities = _cities;
        dist = _dist;
        parent = _parent;
        edge_dist = _edge_dist;
    }
};

queue < node > q;
pair < ll, ll > path[maxn];
vector < pair < ll, ll > > v[maxn];
vector < pair < ll, ll > > tree[maxn];

void init_path() {
   q.push({1, -1, 0, 0, 0});
   path[1] = {-1, 0};
   while (!q.empty()) {
       node top = q.front();
       q.pop();
       if (top.dist > path[top.x].second) continue;
       tree[top.parent].push_back({top.x, top.edge_dist});
       tree[top.x].push_back({top.parent, top.edge_dist});
       //cout << "edge: " << top.parent << " -> " << top.x << ' ' << top.edge_dist << '\n';
       //cout << "top: " << top.x << ' ' << top.cities << ' ' << top.dist << '\n';
       for (auto p : v[top.x]) {
            ll y = p.first;
            ll ed = p.second;
            if (path[y].first == -2 || (path[y].first == top.cities+1 && path[y].second > top.dist + ed)) {
                path[y] = {top.cities+1, top.dist + ed};
                q.push({y, top.cities+1, top.dist + ed, top.x, ed});
            }
       }
   }
}

ll n, m, queries;

ll depth[maxn], dist[maxn];
pair < ll, ll > time1[maxn];
ll timer = 0;

void dfs(ll x, ll p, ll ed) {
    time1[x].first = ++timer;
    depth[x] = depth[p] + 1;
    dist[x] = dist[p] + ed;
    for (auto edge : tree[x]) {
        if (edge.first == p) continue;
        dfs(edge.first, x, edge.second);
    }
    time1[x].second = ++timer;
    //cout << "time1: " << x << ' ' << time1[x].first << ' ' << time1[x].second << '\n';
}

pair < ll, ll > lca(ll x, ll y) {
    if (depth[y] < depth[x]) return {-1, -1};

    if (time1[x].first < time1[y].first && time1[y].second < time1[x].second) {
        return {depth[y] - depth[x] -1, dist[y] - dist[x]};
    }

    return {-1, -1};
}

ll x, y, d;

int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    for (ll i = 0 ; i < maxn ; ++i)
        path[i] = {-2, inf};
    cin >> n >> m;
    for (ll i = 0 ; i < m ; ++i) {
        cin >> x >> y >> d;
        v[x].push_back({y, d});
        v[y].push_back({x, d});
    }
    init_path();
    cout << path[n].first << ' ' << path[n].second << '\n';
    cin >> queries;
    if (queries == 0) return 0;
    dfs(1, 0, 0);
    for (ll i = 1 ; i <= queries ; ++i) {
        cin >> x >> y;
        if (x == y) {
            cout << 0 << ' ' << 0 << '\n';
            continue;
        }
        auto res = lca(x, y);
        if (res.second == -1) cout << 0 << '\n';
        else cout << res.first  << ' ' << res.second << '\n';
    }
    return 0;
}

/*
5 6
1 2 1
2 3 2
1 3 5
3 4 1
3 5 3
4 5 1
3
2 3
3 5
1 4


7 7
1 2 2
2 4 5
2 3 3
3 4 1
4 6 3
4 5 2
3 7 1
4
2 5
2 6
3 7
1 6

*/