#include <iostream>
#include <queue>
#include <vector>
#include <limits.h>
using namespace std;
//typedef long long int;
const int maxn = 4e5+10, maxm = 8e5+10, maxt = 1e4+10, inf = INT_MAX, buff_size = 2e5;
int buff_ix = buff_size-1;
char buff[buff_size];
void read_char() {
    if (++buff_ix == buff_size) fread(buff, buff_size, 1, stdin), buff_ix = 0;
}
void read_int(int &ret) {
    ret = 0;
    for (; buff[buff_ix] < '0' || buff[buff_ix] > '9'; read_char());
    for (; buff[buff_ix] >= '0' && buff[buff_ix] <= '9'; read_char())
        ret = 10*ret + buff[buff_ix] - '0';
}

struct node {
    int x, cities, dist, parent, edge_dist;
    node(){}
    node(int _x, int _cities, int _dist, int _parent, int _edge_dist) {
        x = _x;
        cities = _cities;
        dist = _dist;
        parent = _parent;
        edge_dist = _edge_dist;
    }
};

queue < node > q;
pair < int, int > path[maxn];
vector < pair < int, int > > v[maxn];
vector < pair < int, int > > tree[maxn];

void init_path() {
   q.push({1, -1, 0, 0, 0});
   path[1] = {-1, 0};
   while (!q.empty()) {
       node top = q.front();
       q.pop();
       if (top.dist > path[top.x].second) continue;
       tree[top.parent].push_back({top.x, top.edge_dist});
       tree[top.x].push_back({top.parent, top.edge_dist});
       //cout << "edge: " << top.parent << " -> " << top.x << ' ' << top.edge_dist << '\n';
       //cout << "top: " << top.x << ' ' << top.cities << ' ' << top.dist << '\n';
       for (auto p : v[top.x]) {
            int y = p.first;
            int ed = p.second;
            if (path[y].first == -2 || (path[y].first == top.cities+1 && path[y].second > top.dist + ed)) {
                path[y] = {top.cities+1, top.dist + ed};
                q.push({y, top.cities+1, top.dist + ed, top.x, ed});
            }
       }
   }
}

int n, m, queries;

int depth[maxn], dist[maxn];
pair < int, int > time1[maxn];
int timer = 0;

void dfs(int x, int p, int ed) {
    time1[x].first = ++timer;
    depth[x] = depth[p] + 1;
    dist[x] = dist[p] + ed;
    for (auto edge : tree[x]) {
        if (edge.first == p) continue;
        dfs(edge.first, x, edge.second);
    }
    time1[x].second = ++timer;
    //cout << "time1: " << x << ' ' << time1[x].first << ' ' << time1[x].second << '\n';
}

pair < int, int > lca(int x, int y) {
    if (depth[y] < depth[x]) return {-1, -1};

    if (time1[x].first < time1[y].first && time1[y].second < time1[x].second) {
        return {depth[y] - depth[x] -1, dist[y] - dist[x]};
    }

    return {-1, -1};
}

int x, y, d;

int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    for (int i = 0 ; i < maxn ; ++i)
        path[i] = {-2, inf};
    read_int(n);
    read_int(m);
    for (int i = 0 ; i < m ; ++i) {
        read_int(x);
        read_int(y);
        read_int(d);
        v[x].push_back({y, d});
        v[y].push_back({x, d});
    }
    init_path();
    cout << path[n].first << ' ' << path[n].second << '\n';
    read_int(queries);
    if (queries == 0) return 0;
    dfs(1, 0, 0);
    for (int i = 1 ; i <= queries ; ++i) {
        read_int(x);
        read_int(y);
        if (x == y) {
            cout << 0 << ' ' << 0 << '\n';
            continue;
        }
        auto res = lca(x, y);
        if (res.second == -1) cout << 0 << '\n';
        else cout << res.first  << ' ' << res.second << '\n';
    }
    return 0;
}

/*
5 6
1 2 1
2 3 2
1 3 5
3 4 1
3 5 3
4 5 1
3
2 3
3 5
1 4


7 7
1 2 2
2 4 5
2 3 3
3 4 1
4 6 3
4 5 2
3 7 1
4
2 5
2 6
3 7
1 6

*/