#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<cstring>
#include<map>
#include<unordered_map>
#include<queue>
using namespace std;

const int maxn = (8*1e5)+1;
int n, m, d[maxn], path[maxn];
bool used[maxn];
unordered_map< pair <int, int> , int> mymap;
struct edge
{
    int p, ver;
    edge(){}
    edge(int _p, int _ver)
    {
        p = _p;
        ver = _ver;
    }
    bool operator<(const edge&e)const
    {
        return p>e.p;
    }
};
vector<edge> v[maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    int i, x, y, t;
    for(i=1; i<=m; ++i)
    {
        cin >> x >> y >> t ;
        if(mymap[{x,y}]==0 || mymap[{x,y}]>t) mymap[{x,y}] = t;
    }
}

void init()
{
    pair <int, int> p;
    int t;
    map< pair <int, int> , int> :: iterator it;
    for(it=mymap.begin(); it!=mymap.end(); ++it)
    {
        p = it->first;
        t = it->second;
        v[p.first].push_back({t, p.second});
        v[p.second].push_back({t, p.first});
    }
}

void Dijkstra(int s)
{
    path[s] = 1;
    memset(d, -1, sizeof(d));
    d[s] = 0;
    memset(used, 0, sizeof(used));
    edge e(0, s);
    priority_queue<edge> q;
    q.push(e);
    while(!q.empty())
    {
        e = q.top();
        q.pop();
        //if(d[e.ver] == -1 || e.p <= d[e.ver])
        //{
            if(!used[e.ver])
            {
                used[e.ver] = true;
                int i, len = v[e.ver].size();
                edge nb;
                for(i=0; i<len; ++i)
                {
                    nb = v[e.ver][i];
                    if(d[nb.ver] == -1 || e.p+nb.p < d[nb.ver])
                    {
                        nb.p += e.p;
                        d[nb.ver] = nb.p;
                        q.push(nb);
                        path[nb.ver] = path[e.ver]+1;
                    }
                }
            }
        //}
    }
}

void print()
{
    Dijkstra(1);
    cout << path[n]-2 << " " << d[n] << endl;
}

int main()
{
    read();
    init();
    print();
    return 0;
}
