#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;
const int maxn = 2e5 + 10;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

struct edge
{
    int ver, len;
    ll path;

    bool operator < (const edge &e) const
    {
        if (len < e.len)
            return false;
        if (len > e.len)
            return true;
        if (path < e.path)
            return false;
        return true;
    }
};

int n, m, used1[maxn], to_get1[maxn], to_get2[maxn], used2[maxn];
long long d1[maxn];
long long d2[maxn];
vector < pair < int, long long > > g[maxn];
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i ++)
    {
        int a, b;
        long long w;
        cin >> a >> b >> w;
        g[a].push_back({b, w});
        g[b].push_back({a, w});
    }
}

void djikstra(int s)
{
    for (int i = 1; i <= n; i ++)
        d1[i] = 1e18, to_get1[i] = n + 10;

    priority_queue < edge > pq;
    d1[s] = 0;
    to_get1[s] = 0;
    edge e;
    e.ver = s;
    e.len = 0;
    e.path = 0;
    pq.push(e);
    while(!pq.empty())
    {
        e = pq.top();
        pq.pop();
        if (!used1[e.ver])
            if (e.path <= d1[e.ver] && e.len <= to_get1[e.ver])
            {
                used1[e.ver] = 1;
                for (pair < int, long long > to : g[e.ver])
                {
                    if (e.path + to.second < d1[to.first] && e.len + 1 <= to_get1[to.first])
                    {
                        edge nb;
                        nb.ver = to.first;
                        nb.path = e.path + to.second;
                        nb.len = e.len + 1;
                        d1[to.first] = nb.path;
                        to_get1[to.first] = nb.len;
                        pq.push(nb);
                    }
                }
            }
    }
}

void djikstra2(int s)
{
    for (int i = 1; i <= n; i ++)
        d2[i] = 1e18, to_get2[i] = n + 10;

    priority_queue < edge > pq;
    d2[s] = 0;
    to_get2[s] = 0;
    edge e;
    e.ver = s;
    e.len = 0;
    e.path = 0;
    pq.push(e);
    while(!pq.empty())
    {
        e = pq.top();
        pq.pop();
        if (!used2[e.ver])
            if (e.path <= d2[e.ver] && e.len <= to_get2[e.ver])
            {
                used2[e.ver] = 1;
                for (pair < int, long long > to : g[e.ver])
                {
                    if (e.path + to.second < d2[to.first] && e.len + 1 <= to_get2[to.first])
                    {
                        edge nb;
                        nb.ver = to.first;
                        nb.path = e.path + to.second;
                        nb.len = e.len + 1;
                        d2[to.first] = nb.path;
                        to_get2[to.first] = nb.len;
                        pq.push(nb);
                    }
                }
            }
    }
}
void solve()
{
    djikstra(1);
    djikstra2(n);
    cout << to_get1[n] - 1 << " " << d1[n] << endl;
    int q;
    cin >> q;
    for (int i = 0; i < q; i ++)
    {
        int x, y;
        cin >> x >> y;
        ///int len = to_get1[x] + to_get2[x];
        int p1 = max(to_get1[x] - 1, 0), p2 = max(0, to_get2[x] - 1);
        int len = p1 + p2;
        if (x != 1 && x != n)
            len ++;
        ///cout << len << endl;
        ///cout << to_get1[x] << " " << to_get2[x] << endl;
        if (len == to_get1[n] - 1)
        {
            cout << max(0, to_get2[x] - 1) << " " << d2[x] << endl;
        }
        else
        {
            cout << 0 << endl;
        }
    }
}
int main()
{
    speed();
    read();
    solve();
    return 0;
}
/**
6 6
1 2 3
1 3 5
3 4 8
4 6 2
2 5 4
5 6 7
0
*/
